
/*
  EDMA Advanced Class CRYPT_BASE
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : CRYPT_BASE
    Description : Base Clase for cryptographic filters
                  This is mainly an example hierarchy for the
		  mixin examples
    Author      : David Martnez Oliviera
    Date        : December, 15th, 2001
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class CRYPT_BASE
***************************************************
*/
 
typedef struct
  {
     EPChar		Password;
     EPChar		Codec;
}DtCRYPT_BASE;
/*
***************************************************
  Method Declaration for class Codec
***************************************************
*/
 
ESint32 EDMAPROC 
CRYPT_BASESetPasswordZrS32 (OBJID IdObj,EPChar p)
{
  DtCRYPT_BASE	*m;

  m = (DtCRYPT_BASE*) edma_get_data_ref (IdObj);
  edma_printf_obj (IdObj,"Setting Password");
  edma_wprop3 (IdObj,"Password",p);
  /* This class'll be override by subclasses to allow process the password
     provided by the applictions
     
     Maybe it'll be abstract, by for the moment I maintain it to do test
     on dynamic inheritance in GNU EDMA
  */
  return 0;
}

ESint32 EDMAPROC 
CRYPT_BASEsetCodecZrS32 (OBJID IdObj,EPChar Name)
{
  DtCRYPT_BASE	*m;
  EPChar       cId[2]={"IMP",NULL};
  EPChar       c[2]={NULL,NULL};
  POBJ         pObj;
  
  m = (DtCRYPT_BASE*)edma_get_data_ref(IdObj);
  c[0] = Name;
  pObj = edma_get_obj_pobj (IdObj);
  edma_mutate_obj1 (pObj,c,cId);
  
  /* SubClasses'll override abstract ans virtual methods */
  return 0;
}



/********** END C IMPLEMENTATION SKELETON ******************/
